import { useGenericAuth } from '@envelop/generic-auth'
import { MeshPlugin } from '@graphql-mesh/types'

type UserType = {
    id: string
}

const resolveUserFn = async context => {
    const authHeader = context.req.headers.authorization;
    const authtoken = process.env.GRAPHQL_MESH
    if (authHeader !== authtoken) {
        console.error('Failed to validate token')
        return null
    }
    return { id: 'user1' };
}

const validateUser = params => {
    if (!params.user) {
        return new Error(`Unauthenticated!`)
    }
}

const plugins: MeshPlugin = [
    useGenericAuth({
        resolveUserFn,
        validateUser,
        mode: 'protect-all'
    })
]

export default plugins